/* 
 * nngfs/util/nngfs.h
 * 
 * Copyright (C) 2008
 * Manish Katiyar (mkatiyar@gmail.com) 
 *
 * NNGFS userspace header file distributed under GPL
 */

#define NNGFS_MAGIC 0x4E474653  /* "NNGFS" */
#define NNGFS_NAME_LEN 16
#define NNGFS_ROOT_BLOCK 1
#define NNGFS_INODE_BLOCK 1
#define NNGFS_CLEAN 0
#define NNGFS_DIRTY ~(NNGFS_CLEAN)
#define NNGFS_ROOT_INODE NNGFS_ROOT_BLOCK
#define NNGFS_FILE (S_IFREG|S_IRUSR|S_IWUSR|S_IXUSR|S_IROTH|S_IXOTH|S_IRGRP|S_IXGRP)
#define NNGFS_DIR  (S_IFDIR|S_IRUSR|S_IWUSR|S_IXUSR|S_IROTH|S_IXOTH|S_IRGRP|S_IXGRP)


typedef unsigned short unsigned16;
typedef unsigned int unsigned32;

struct nngfs_inode {
        unsigned32 inode;
        unsigned32 blockno; // Block number where data resides. No file is more than a block size. = inode+1
        unsigned16 filetype;
        unsigned16 uid;
        unsigned16 gid;
	unsigned16 size;
        unsigned16 perm;
        struct timespec atime;
        struct timespec ctime;
        struct timespec mtime;
        unsigned32 magic;
};

struct nngfs_superblock {
        unsigned32 magic;
        unsigned32 block_bitmap;
        unsigned32 inode_bitmap; //Restricts max number of files to 32
        unsigned32 dirty;
        unsigned16 blocksize;
        unsigned32 root_inode;
	unsigned32 inodes; //File system node counts. Should be 32 for our implementation
	unsigned32 blocks;  //Filesystem size in blocks;
        unsigned16 free_blocks;  // We dont need a free inode counter as 1 inode can have only 1 block max 
        unsigned16 first_data_block;
};
	
struct nngfs_dir_entry {
   	unsigned32 inode;
	unsigned32 rec_len;
	unsigned32 name_len;
	char name[NNGFS_NAME_LEN];
};

